function generate(infile,outfile,sigma)
% function generate(infile,outfile,sigma)
% Read original image from <infile>
% Add Gaussian noise with variance sigma^2
% Write the noisy image as <outfile>
% Inputs:
%   infile  : original image (8bit/pixel, [0 255] grayscale)
%   outfile : noisey image (double array)
%   sigma   : standard deviation of noise

disp(inputname(1));
fid = fopen(infile,'r');
org = fread(fid,[512 512],'uchar');
org = org';
 
sigman = sigma;
randn('seed',sum(100*clock));
noise = sigman*randn(512);
noisy_image = org + noise;
noisy_image = noisy_image/255.0;

fid = fopen(outfile,'w');
fwrite(fid,noisy_image','double');
fclose(fid);
