/*
File Name: hmt.h
Last Modification Date:	%G%	%U%
Current Version: %M%	%I%
File Creation Date: Wed May  5 11:40:48 1999
Author: Hyeokho Choi  <choi@ece.rice.edu>

Copyright: All software, documentation, and related files in this distribution
           are Copyright (c) 1999  Rice University

Permission is granted for use and non-profit distribution providing that this
notice be clearly maintained. The right to distribute any portion for profit
or as part of any commercial product is specifically reserved for the author.

Change History:

*/

typedef struct smu {
  double S; /* mean for "small" state */
  double L; /* mean for "large" state */
} mu;
 
typedef struct ssi {
  double S; /* variance for "small" state */
  double L; /* variance for "large" state */
} si;
 
typedef struct sps {
  double S; /* state probability for "small" state */
  double L; /* state probability for "large" state */
} ps;
 
typedef struct ses {
  double SS; /* state transition probability for S->S states */
  double SL; /* state transition prob for S->L states */
  double LS; /* state transition prob for L->S states */
  double LL; /* state transition prob for L->L states */
} es;




mu **mumatrix(int,int);
void free_mumatrix();
si **simatrix(int,int);
void free_simatrix();
ps **psmatrix(int,int);
void free_psmatrix();
es **esmatrix(int,int);
void free_esmatrix();

double *vector();
int *ivector();
void free_vector();
void free_ivector();
double **matrix();
void free_matrix();

void initialize();
void copy_para();
int l2();
int power2();
double conerr();

void emhht();
void emhlt();
void emlht();

void posthh();
void posthl();
void postlh();

double gauss();

void rdmatrix();
void wtmatrix();

double noisevar();
void emwiener();

double *conv();
double *cconv();
void cdwt2();
void cidwt2();
void dwt2daub8();
void uhmt();

