function showresult(o_image, n_image, d_image)
% function showresult(o_image, n_image, d_image)
% Display denoising results with PSNRs
% Inputs:
%   o_image : original image file (8bit/pixel, [0,255] gray scale format)
%   n_image : noisy image file (double arrary)
%   d_image : denoised image file (double array)

fid = fopen(d_image,'r');
xd = fread(fid, [512 512],'double');
fclose(fid);
xd = xd';

fid = fopen(n_image,'r');
xn = fread(fid,[512 512],'double');
fclose(fid);
xn = xn';

fid = fopen(o_image,'r');
org = fread(fid,[512 512],'uchar');
fclose(fid);
org = org'/255.0;


disp(['PSNR of noisy image is ' num2str(psnr(org,xn)) 'dB']);
disp(['PSNR of denoised image is ' num2str(psnr(org,xd)) 'dB']);

figure(1);
colormap(gray(256));
image(org*255.0+1);
axis square;
title('original image');

figure(2);
colormap(gray(256));
image(xn*255.0+1);
axis square;
title('noisy image');

figure(3);
colormap(gray(256));
image(xd*255.0+1);
axis square;
title('denoised image');


